"""alembic is actually behaving so this message will be nice :)

Revision ID: cf61f006db46
Revises: 
Create Date: 2025-04-25 14:34:28.206737

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = 'cf61f006db46'
down_revision: Union[str, None] = None
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    """Upgrade schema."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('critical_error_logs',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('error_message', sa.String(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_critical_error_logs_id'), 'critical_error_logs', ['id'], unique=False)
    op.create_table('customers',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_customers_id'), 'customers', ['id'], unique=False)
    op.create_index(op.f('ix_customers_name'), 'customers', ['name'], unique=False)
    op.create_table('files',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('file_type', sa.String(), nullable=True),
    sa.Column('content_type', sa.String(), nullable=True),
    sa.Column('path', sa.String(), nullable=True),
    sa.Column('size', sa.Integer(), nullable=True),
    sa.Column('file_metadata', sa.JSON(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_files_id'), 'files', ['id'], unique=False)
    op.create_table('marketplaces',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_marketplaces_id'), 'marketplaces', ['id'], unique=False)
    op.create_index(op.f('ix_marketplaces_name'), 'marketplaces', ['name'], unique=False)
    op.create_table('most_recent_tcgplayer_price',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('product_id', sa.Integer(), nullable=False),
    sa.Column('sub_type_name', sa.String(), nullable=True),
    sa.Column('date', sa.DateTime(), nullable=False),
    sa.Column('low_price', sa.Float(), nullable=True),
    sa.Column('mid_price', sa.Float(), nullable=True),
    sa.Column('high_price', sa.Float(), nullable=True),
    sa.Column('market_price', sa.Float(), nullable=True),
    sa.Column('direct_low_price', sa.Float(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index('idx_most_recent_price_product_subtype', 'most_recent_tcgplayer_price', ['product_id', 'sub_type_name'], unique=True)
    op.create_index(op.f('ix_most_recent_tcgplayer_price_product_id'), 'most_recent_tcgplayer_price', ['product_id'], unique=False)
    op.create_index(op.f('ix_most_recent_tcgplayer_price_sub_type_name'), 'most_recent_tcgplayer_price', ['sub_type_name'], unique=False)
    op.create_table('mtgjson_cards',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('mtgjson_uuid', sa.String(), nullable=True),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('set_code', sa.String(), nullable=True),
    sa.Column('abu_id', sa.String(), nullable=True),
    sa.Column('card_kingdom_etched_id', sa.String(), nullable=True),
    sa.Column('card_kingdom_foil_id', sa.String(), nullable=True),
    sa.Column('card_kingdom_id', sa.String(), nullable=True),
    sa.Column('cardsphere_id', sa.String(), nullable=True),
    sa.Column('cardsphere_foil_id', sa.String(), nullable=True),
    sa.Column('cardtrader_id', sa.String(), nullable=True),
    sa.Column('csi_id', sa.String(), nullable=True),
    sa.Column('mcm_id', sa.String(), nullable=True),
    sa.Column('mcm_meta_id', sa.String(), nullable=True),
    sa.Column('miniaturemarket_id', sa.String(), nullable=True),
    sa.Column('mtg_arena_id', sa.String(), nullable=True),
    sa.Column('mtgjson_foil_version_id', sa.String(), nullable=True),
    sa.Column('mtgjson_non_foil_version_id', sa.String(), nullable=True),
    sa.Column('mtgjson_v4_id', sa.String(), nullable=True),
    sa.Column('mtgo_foil_id', sa.String(), nullable=True),
    sa.Column('mtgo_id', sa.String(), nullable=True),
    sa.Column('multiverse_id', sa.String(), nullable=True),
    sa.Column('scg_id', sa.String(), nullable=True),
    sa.Column('scryfall_id', sa.String(), nullable=True),
    sa.Column('scryfall_card_back_id', sa.String(), nullable=True),
    sa.Column('scryfall_oracle_id', sa.String(), nullable=True),
    sa.Column('scryfall_illustration_id', sa.String(), nullable=True),
    sa.Column('tcgplayer_product_id', sa.Integer(), nullable=True),
    sa.Column('tcgplayer_etched_product_id', sa.Integer(), nullable=True),
    sa.Column('tnt_id', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['mtgjson_uuid'], ['mtgjson_cards.mtgjson_uuid'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('mtgjson_uuid', name='uq_card_mtgjson_uuid')
    )
    op.create_index(op.f('ix_mtgjson_cards_id'), 'mtgjson_cards', ['id'], unique=False)
    op.create_index(op.f('ix_mtgjson_cards_mtgjson_uuid'), 'mtgjson_cards', ['mtgjson_uuid'], unique=True)
    op.create_table('sealed_expected_values',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('tcgplayer_product_id', sa.Integer(), nullable=False),
    sa.Column('expected_value', sa.Float(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index('idx_sealed_expected_value_product_id_deleted_at', 'sealed_expected_values', ['tcgplayer_product_id', 'deleted_at'], unique=True)
    op.create_index(op.f('ix_sealed_expected_values_id'), 'sealed_expected_values', ['id'], unique=False)
    op.create_table('tcgplayer_categories',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('category_id', sa.Integer(), nullable=True),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('display_name', sa.String(), nullable=True),
    sa.Column('seo_category_name', sa.String(), nullable=True),
    sa.Column('category_description', sa.String(), nullable=True),
    sa.Column('category_page_title', sa.String(), nullable=True),
    sa.Column('sealed_label', sa.String(), nullable=True),
    sa.Column('non_sealed_label', sa.String(), nullable=True),
    sa.Column('condition_guide_url', sa.String(), nullable=True),
    sa.Column('is_scannable', sa.Boolean(), nullable=True),
    sa.Column('popularity', sa.Integer(), nullable=True),
    sa.Column('is_direct', sa.Boolean(), nullable=True),
    sa.Column('modified_on', sa.DateTime(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tcgplayer_categories_category_id'), 'tcgplayer_categories', ['category_id'], unique=True)
    op.create_index(op.f('ix_tcgplayer_categories_id'), 'tcgplayer_categories', ['id'], unique=False)
    op.create_table('tcgplayer_order_products',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('order_number', sa.String(), nullable=True),
    sa.Column('product_name', sa.String(), nullable=True),
    sa.Column('unit_price', sa.Float(), nullable=True),
    sa.Column('extended_price', sa.Float(), nullable=True),
    sa.Column('quantity', sa.Integer(), nullable=True),
    sa.Column('url', sa.String(), nullable=True),
    sa.Column('product_id', sa.Integer(), nullable=True),
    sa.Column('sku_id', sa.Integer(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tcgplayer_order_products_id'), 'tcgplayer_order_products', ['id'], unique=False)
    op.create_index(op.f('ix_tcgplayer_order_products_order_number'), 'tcgplayer_order_products', ['order_number'], unique=False)
    op.create_table('tcgplayer_order_refunds',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('order_number', sa.String(), nullable=True),
    sa.Column('refund_created_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('type', sa.String(), nullable=True),
    sa.Column('amount', sa.Float(), nullable=True),
    sa.Column('description', sa.String(), nullable=True),
    sa.Column('origin', sa.String(), nullable=True),
    sa.Column('shipping_amount', sa.Float(), nullable=True),
    sa.Column('products', sa.JSON(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tcgplayer_order_refunds_id'), 'tcgplayer_order_refunds', ['id'], unique=False)
    op.create_index(op.f('ix_tcgplayer_order_refunds_order_number'), 'tcgplayer_order_refunds', ['order_number'], unique=False)
    op.create_table('tcgplayer_order_transactions',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('order_number', sa.String(), nullable=True),
    sa.Column('product_amount', sa.Float(), nullable=True),
    sa.Column('shipping_amount', sa.Float(), nullable=True),
    sa.Column('gross_amount', sa.Float(), nullable=True),
    sa.Column('fee_amount', sa.Float(), nullable=True),
    sa.Column('net_amount', sa.Float(), nullable=True),
    sa.Column('direct_fee_amount', sa.Float(), nullable=True),
    sa.Column('taxes', sa.JSON(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tcgplayer_order_transactions_id'), 'tcgplayer_order_transactions', ['id'], unique=False)
    op.create_index(op.f('ix_tcgplayer_order_transactions_order_number'), 'tcgplayer_order_transactions', ['order_number'], unique=False)
    op.create_table('tcgplayer_orders',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('order_number', sa.String(), nullable=True),
    sa.Column('order_created_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('status', sa.String(), nullable=True),
    sa.Column('channel', sa.String(), nullable=True),
    sa.Column('fulfillment', sa.String(), nullable=True),
    sa.Column('seller_name', sa.String(), nullable=True),
    sa.Column('buyer_name', sa.String(), nullable=True),
    sa.Column('payment_type', sa.String(), nullable=True),
    sa.Column('pickup_status', sa.String(), nullable=True),
    sa.Column('shipping_type', sa.String(), nullable=True),
    sa.Column('estimated_delivery_date', sa.DateTime(timezone=True), nullable=True),
    sa.Column('recipient_name', sa.String(), nullable=True),
    sa.Column('address_line_1', sa.String(), nullable=True),
    sa.Column('address_line_2', sa.String(), nullable=True),
    sa.Column('city', sa.String(), nullable=True),
    sa.Column('state', sa.String(), nullable=True),
    sa.Column('zip_code', sa.String(), nullable=True),
    sa.Column('country', sa.String(), nullable=True),
    sa.Column('tracking_numbers', sa.JSON(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tcgplayer_orders_id'), 'tcgplayer_orders', ['id'], unique=False)
    op.create_index(op.f('ix_tcgplayer_orders_order_number'), 'tcgplayer_orders', ['order_number'], unique=False)
    op.create_table('tcgplayer_price_history',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('product_id', sa.Integer(), nullable=False),
    sa.Column('sub_type_name', sa.String(), nullable=True),
    sa.Column('date', sa.DateTime(), nullable=True),
    sa.Column('low_price', sa.Float(), nullable=True),
    sa.Column('mid_price', sa.Float(), nullable=True),
    sa.Column('high_price', sa.Float(), nullable=True),
    sa.Column('market_price', sa.Float(), nullable=True),
    sa.Column('direct_low_price', sa.Float(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index('idx_price_history_product_subtype_date', 'tcgplayer_price_history', ['product_id', 'sub_type_name', 'date'], unique=False)
    op.create_index(op.f('ix_tcgplayer_price_history_date'), 'tcgplayer_price_history', ['date'], unique=False)
    op.create_index(op.f('ix_tcgplayer_price_history_id'), 'tcgplayer_price_history', ['id'], unique=False)
    op.create_index(op.f('ix_tcgplayer_price_history_product_id'), 'tcgplayer_price_history', ['product_id'], unique=False)
    op.create_index(op.f('ix_tcgplayer_price_history_sub_type_name'), 'tcgplayer_price_history', ['sub_type_name'], unique=False)
    op.create_table('vendors',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_vendors_id'), 'vendors', ['id'], unique=False)
    op.create_index(op.f('ix_vendors_name'), 'vendors', ['name'], unique=False)
    op.create_table('manabox_import_staging',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('file_id', sa.Integer(), nullable=True),
    sa.Column('tcgplayer_product_id', sa.Integer(), nullable=True),
    sa.Column('tcgplayer_sku_id', sa.Integer(), nullable=True),
    sa.Column('quantity', sa.Integer(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['file_id'], ['files.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('tcgplayer_groups',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('group_id', sa.Integer(), nullable=True),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('abbreviation', sa.String(), nullable=True),
    sa.Column('is_supplemental', sa.Boolean(), nullable=True),
    sa.Column('published_on', sa.DateTime(), nullable=True),
    sa.Column('modified_on', sa.DateTime(), nullable=True),
    sa.Column('category_id', sa.Integer(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['category_id'], ['tcgplayer_categories.category_id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tcgplayer_groups_group_id'), 'tcgplayer_groups', ['group_id'], unique=True)
    op.create_index(op.f('ix_tcgplayer_groups_id'), 'tcgplayer_groups', ['id'], unique=False)
    op.create_table('transactions',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('vendor_id', sa.Integer(), nullable=True),
    sa.Column('customer_id', sa.Integer(), nullable=True),
    sa.Column('marketplace_id', sa.Integer(), nullable=True),
    sa.Column('transaction_type', sa.String(), nullable=True),
    sa.Column('transaction_date', sa.DateTime(timezone=True), nullable=True),
    sa.Column('transaction_total_amount', sa.Float(), nullable=True),
    sa.Column('transaction_notes', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['customer_id'], ['customers.id'], ),
    sa.ForeignKeyConstraint(['marketplace_id'], ['marketplaces.id'], ),
    sa.ForeignKeyConstraint(['vendor_id'], ['vendors.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_transactions_id'), 'transactions', ['id'], unique=False)
    op.create_table('tcgplayer_products',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('tcgplayer_product_id', sa.Integer(), nullable=False),
    sa.Column('normalized_sub_type_name', sa.String(), nullable=False),
    sa.Column('sub_type_name', sa.String(), nullable=True),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('clean_name', sa.String(), nullable=True),
    sa.Column('image_url', sa.String(), nullable=True),
    sa.Column('category_id', sa.Integer(), nullable=True),
    sa.Column('group_id', sa.Integer(), nullable=True),
    sa.Column('url', sa.String(), nullable=True),
    sa.Column('modified_on', sa.DateTime(), nullable=True),
    sa.Column('image_count', sa.Integer(), nullable=True),
    sa.Column('ext_rarity', sa.String(), nullable=True),
    sa.Column('ext_subtype', sa.String(), nullable=True),
    sa.Column('ext_oracle_text', sa.String(), nullable=True),
    sa.Column('ext_number', sa.String(), nullable=True),
    sa.Column('low_price', sa.Float(), nullable=True),
    sa.Column('mid_price', sa.Float(), nullable=True),
    sa.Column('high_price', sa.Float(), nullable=True),
    sa.Column('market_price', sa.Float(), nullable=True),
    sa.Column('direct_low_price', sa.Float(), nullable=True),
    sa.Column('ext_power', sa.String(), nullable=True),
    sa.Column('ext_toughness', sa.String(), nullable=True),
    sa.Column('ext_flavor_text', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['category_id'], ['tcgplayer_categories.category_id'], ),
    sa.ForeignKeyConstraint(['group_id'], ['tcgplayer_groups.group_id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('tcgplayer_product_id', 'normalized_sub_type_name', name='uq_product_subtype')
    )
    op.create_index(op.f('ix_tcgplayer_products_id'), 'tcgplayer_products', ['id'], unique=False)
    op.create_table('mtgjson_skus',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('mtgjson_uuid', sa.String(), nullable=True),
    sa.Column('tcgplayer_sku_id', sa.Integer(), nullable=True),
    sa.Column('tcgplayer_product_id', sa.Integer(), nullable=False),
    sa.Column('normalized_printing', sa.String(), nullable=False),
    sa.Column('condition', sa.String(), nullable=True),
    sa.Column('finish', sa.String(), nullable=True),
    sa.Column('language', sa.String(), nullable=True),
    sa.Column('printing', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['mtgjson_uuid'], ['mtgjson_cards.mtgjson_uuid'], ),
    sa.ForeignKeyConstraint(['tcgplayer_product_id', 'normalized_printing'], ['tcgplayer_products.tcgplayer_product_id', 'tcgplayer_products.normalized_sub_type_name'], name='fk_sku_to_product_composite'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('mtgjson_uuid', name='uq_sku_mtgjson_uuid')
    )
    op.create_index('idx_sku_product_printing', 'mtgjson_skus', ['tcgplayer_product_id', 'normalized_printing'], unique=False)
    op.create_index(op.f('ix_mtgjson_skus_id'), 'mtgjson_skus', ['id'], unique=False)
    op.create_index(op.f('ix_mtgjson_skus_mtgjson_uuid'), 'mtgjson_skus', ['mtgjson_uuid'], unique=True)
    op.create_index(op.f('ix_mtgjson_skus_tcgplayer_sku_id'), 'mtgjson_skus', ['tcgplayer_sku_id'], unique=True)
    op.create_table('physical_items',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('item_type', sa.String(), nullable=True),
    sa.Column('tcgplayer_product_id', sa.Integer(), nullable=True),
    sa.Column('tcgplayer_sku_id', sa.Integer(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.CheckConstraint('(tcgplayer_sku_id IS NOT NULL OR tcgplayer_product_id IS NOT NULL)', name='ck_physical_items_sku_or_product_not_null'),
    sa.ForeignKeyConstraint(['tcgplayer_sku_id'], ['mtgjson_skus.tcgplayer_sku_id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('tcgplayer_inventory',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('tcgplayer_sku_id', sa.Integer(), nullable=True),
    sa.Column('product_line', sa.String(), nullable=True),
    sa.Column('set_name', sa.String(), nullable=True),
    sa.Column('product_name', sa.String(), nullable=True),
    sa.Column('title', sa.String(), nullable=True),
    sa.Column('number', sa.String(), nullable=True),
    sa.Column('rarity', sa.String(), nullable=True),
    sa.Column('condition', sa.String(), nullable=True),
    sa.Column('tcg_market_price', sa.Float(), nullable=True),
    sa.Column('tcg_direct_low', sa.Float(), nullable=True),
    sa.Column('tcg_low_price_with_shipping', sa.Float(), nullable=True),
    sa.Column('tcg_low_price', sa.Float(), nullable=True),
    sa.Column('total_quantity', sa.Integer(), nullable=True),
    sa.Column('add_to_quantity', sa.Integer(), nullable=True),
    sa.Column('tcg_marketplace_price', sa.Float(), nullable=True),
    sa.Column('photo_url', sa.String(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.ForeignKeyConstraint(['tcgplayer_sku_id'], ['mtgjson_skus.tcgplayer_sku_id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_tcgplayer_inventory_id'), 'tcgplayer_inventory', ['id'], unique=False)
    op.create_index(op.f('ix_tcgplayer_inventory_tcgplayer_sku_id'), 'tcgplayer_inventory', ['tcgplayer_sku_id'], unique=True)
    op.create_table('boxes',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('expected_value', sa.Float(), nullable=True),
    sa.ForeignKeyConstraint(['id'], ['physical_items.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('cards',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['id'], ['physical_items.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('cases',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('expected_value', sa.Float(), nullable=True),
    sa.Column('num_boxes', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['id'], ['physical_items.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('inventory_items',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('physical_item_id', sa.Integer(), nullable=True),
    sa.Column('cost_basis', sa.Float(), nullable=True),
    sa.Column('parent_id', sa.Integer(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['parent_id'], ['inventory_items.id'], ),
    sa.ForeignKeyConstraint(['physical_item_id'], ['physical_items.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('physical_item_id')
    )
    op.create_index(op.f('ix_inventory_items_id'), 'inventory_items', ['id'], unique=False)
    op.create_table('open_events',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('source_item_id', sa.Integer(), nullable=True),
    sa.Column('open_date', sa.DateTime(timezone=True), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['source_item_id'], ['physical_items.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('source_item_id', name='uq_openevent_one_per_source')
    )
    op.create_index(op.f('ix_open_events_id'), 'open_events', ['id'], unique=False)
    op.create_table('marketplace_listings',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('inventory_item_id', sa.Integer(), nullable=False),
    sa.Column('marketplace_id', sa.Integer(), nullable=False),
    sa.Column('listing_date', sa.DateTime(timezone=True), nullable=True),
    sa.Column('delisting_date', sa.DateTime(timezone=True), nullable=True),
    sa.Column('listed_price', sa.Float(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['inventory_item_id'], ['inventory_items.id'], ),
    sa.ForeignKeyConstraint(['marketplace_id'], ['marketplaces.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_marketplace_listings_id'), 'marketplace_listings', ['id'], unique=False)
    op.create_table('open_event_resulting_items',
    sa.Column('event_id', sa.Integer(), nullable=False),
    sa.Column('item_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['event_id'], ['open_events.id'], ),
    sa.ForeignKeyConstraint(['item_id'], ['physical_items.id'], ),
    sa.PrimaryKeyConstraint('event_id', 'item_id')
    )
    op.create_table('transaction_items',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('transaction_id', sa.Integer(), nullable=True),
    sa.Column('inventory_item_id', sa.Integer(), nullable=True),
    sa.Column('unit_price', sa.Float(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), server_default=sa.text('now()'), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['inventory_item_id'], ['inventory_items.id'], ),
    sa.ForeignKeyConstraint(['transaction_id'], ['transactions.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_transaction_items_id'), 'transaction_items', ['id'], unique=False)
    # ### end Alembic commands ###


def downgrade() -> None:
    """Downgrade schema."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_transaction_items_id'), table_name='transaction_items')
    op.drop_table('transaction_items')
    op.drop_table('open_event_resulting_items')
    op.drop_index(op.f('ix_marketplace_listings_id'), table_name='marketplace_listings')
    op.drop_table('marketplace_listings')
    op.drop_index(op.f('ix_open_events_id'), table_name='open_events')
    op.drop_table('open_events')
    op.drop_index(op.f('ix_inventory_items_id'), table_name='inventory_items')
    op.drop_table('inventory_items')
    op.drop_table('cases')
    op.drop_table('cards')
    op.drop_table('boxes')
    op.drop_index(op.f('ix_tcgplayer_inventory_tcgplayer_sku_id'), table_name='tcgplayer_inventory')
    op.drop_index(op.f('ix_tcgplayer_inventory_id'), table_name='tcgplayer_inventory')
    op.drop_table('tcgplayer_inventory')
    op.drop_table('physical_items')
    op.drop_index(op.f('ix_mtgjson_skus_tcgplayer_sku_id'), table_name='mtgjson_skus')
    op.drop_index(op.f('ix_mtgjson_skus_mtgjson_uuid'), table_name='mtgjson_skus')
    op.drop_index(op.f('ix_mtgjson_skus_id'), table_name='mtgjson_skus')
    op.drop_index('idx_sku_product_printing', table_name='mtgjson_skus')
    op.drop_table('mtgjson_skus')
    op.drop_index(op.f('ix_tcgplayer_products_id'), table_name='tcgplayer_products')
    op.drop_table('tcgplayer_products')
    op.drop_index(op.f('ix_transactions_id'), table_name='transactions')
    op.drop_table('transactions')
    op.drop_index(op.f('ix_tcgplayer_groups_id'), table_name='tcgplayer_groups')
    op.drop_index(op.f('ix_tcgplayer_groups_group_id'), table_name='tcgplayer_groups')
    op.drop_table('tcgplayer_groups')
    op.drop_table('manabox_import_staging')
    op.drop_index(op.f('ix_vendors_name'), table_name='vendors')
    op.drop_index(op.f('ix_vendors_id'), table_name='vendors')
    op.drop_table('vendors')
    op.drop_index(op.f('ix_tcgplayer_price_history_sub_type_name'), table_name='tcgplayer_price_history')
    op.drop_index(op.f('ix_tcgplayer_price_history_product_id'), table_name='tcgplayer_price_history')
    op.drop_index(op.f('ix_tcgplayer_price_history_id'), table_name='tcgplayer_price_history')
    op.drop_index(op.f('ix_tcgplayer_price_history_date'), table_name='tcgplayer_price_history')
    op.drop_index('idx_price_history_product_subtype_date', table_name='tcgplayer_price_history')
    op.drop_table('tcgplayer_price_history')
    op.drop_index(op.f('ix_tcgplayer_orders_order_number'), table_name='tcgplayer_orders')
    op.drop_index(op.f('ix_tcgplayer_orders_id'), table_name='tcgplayer_orders')
    op.drop_table('tcgplayer_orders')
    op.drop_index(op.f('ix_tcgplayer_order_transactions_order_number'), table_name='tcgplayer_order_transactions')
    op.drop_index(op.f('ix_tcgplayer_order_transactions_id'), table_name='tcgplayer_order_transactions')
    op.drop_table('tcgplayer_order_transactions')
    op.drop_index(op.f('ix_tcgplayer_order_refunds_order_number'), table_name='tcgplayer_order_refunds')
    op.drop_index(op.f('ix_tcgplayer_order_refunds_id'), table_name='tcgplayer_order_refunds')
    op.drop_table('tcgplayer_order_refunds')
    op.drop_index(op.f('ix_tcgplayer_order_products_order_number'), table_name='tcgplayer_order_products')
    op.drop_index(op.f('ix_tcgplayer_order_products_id'), table_name='tcgplayer_order_products')
    op.drop_table('tcgplayer_order_products')
    op.drop_index(op.f('ix_tcgplayer_categories_id'), table_name='tcgplayer_categories')
    op.drop_index(op.f('ix_tcgplayer_categories_category_id'), table_name='tcgplayer_categories')
    op.drop_table('tcgplayer_categories')
    op.drop_index(op.f('ix_sealed_expected_values_id'), table_name='sealed_expected_values')
    op.drop_index('idx_sealed_expected_value_product_id_deleted_at', table_name='sealed_expected_values')
    op.drop_table('sealed_expected_values')
    op.drop_index(op.f('ix_mtgjson_cards_mtgjson_uuid'), table_name='mtgjson_cards')
    op.drop_index(op.f('ix_mtgjson_cards_id'), table_name='mtgjson_cards')
    op.drop_table('mtgjson_cards')
    op.drop_index(op.f('ix_most_recent_tcgplayer_price_sub_type_name'), table_name='most_recent_tcgplayer_price')
    op.drop_index(op.f('ix_most_recent_tcgplayer_price_product_id'), table_name='most_recent_tcgplayer_price')
    op.drop_index('idx_most_recent_price_product_subtype', table_name='most_recent_tcgplayer_price')
    op.drop_table('most_recent_tcgplayer_price')
    op.drop_index(op.f('ix_marketplaces_name'), table_name='marketplaces')
    op.drop_index(op.f('ix_marketplaces_id'), table_name='marketplaces')
    op.drop_table('marketplaces')
    op.drop_index(op.f('ix_files_id'), table_name='files')
    op.drop_table('files')
    op.drop_index(op.f('ix_customers_name'), table_name='customers')
    op.drop_index(op.f('ix_customers_id'), table_name='customers')
    op.drop_table('customers')
    op.drop_index(op.f('ix_critical_error_logs_id'), table_name='critical_error_logs')
    op.drop_table('critical_error_logs')
    # ### end Alembic commands ###
